//
//  CategoryListViewController.swift
//  xsea
//
//  Created Phạm Anh Tuấn on 8/31/19.
//  Copyright © 2019 Phạm Anh Tuấn. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit

class CategoryListViewController: UIViewController, CategoryListViewProtocol {
    private let loader = LoaderSettings()
    
    @IBOutlet weak var categoryCollectionView: UICollectionView!
    
    func showCategories() {
        DispatchQueue.main.async {
            self.categoryCollectionView.reloadData()
            self.loader.isLunching = false
        }
    }
    

	var presenter: CategoryListPresenterProtocol?

	override func viewDidLoad() {
        super.viewDidLoad()
        self.setupViews()
        loader.isLunching = true
        CategoryListRouter.createModule(view: self)
        presenter?.getCategories()
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        self.navigationController?.navigationBar.isHidden = true
    }
}

extension CategoryListViewController{
    private func setupViews(){
        self.navigationController?.navigationBar.isHidden = true
        self.setupCategoryCollectionView()
    }
}

extension CategoryListViewController: UICollectionViewDataSource, UICollectionViewDelegate, UICollectionViewDelegateFlowLayout {
    
    private func setupCategoryCollectionView(){
        self.categoryCollectionView.dataSource = self
        self.categoryCollectionView.delegate = self
        
        self.categoryCollectionView.register(UINib(nibName: CategoryCell.xibName, bundle: nil), forCellWithReuseIdentifier: CategoryCell.identifier)
        
        self.categoryCollectionView.contentInset = UIEdgeInsets(top: 8, left: 8, bottom: 8, right: 8)
        self.categoryCollectionView.showsVerticalScrollIndicator = false
    }
    
    func numberOfSections(in collectionView: UICollectionView) -> Int {
        return 1
    }
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return self.presenter?.categories.count ?? 0
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: CategoryCell.identifier, for: indexPath) as! CategoryCell
        cell.viewColor = GradientColorList.colors[indexPath.item % GradientColorList.count]
        cell.data = presenter?.categories[indexPath.item]
        return cell
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        return CGSize(width: collectionView.frame.width, height: 300)
    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        presenter?.showCategoryDetail(selectedIndex: indexPath.item)
    }

    
}
